// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::RefKind;
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "FlatpakRef")]
    pub struct Ref(Object<ffi::FlatpakRef, ffi::FlatpakRefClass>);

    match fn {
        type_ => || ffi::flatpak_ref_get_type(),
    }
}

impl Ref {
    pub const NONE: Option<&'static Ref> = None;

    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`Ref`] objects.
    ///
    /// This method returns an instance of [`RefBuilder`](crate::builders::RefBuilder) which can be used to create [`Ref`] objects.
    pub fn builder() -> RefBuilder {
        RefBuilder::new()
    }

    #[doc(alias = "flatpak_ref_parse")]
    pub fn parse(ref_: &str) -> Result<Ref, glib::Error> {
        assert_initialized_main_thread!();
        unsafe {
            let mut error = std::ptr::null_mut();
            let ret = ffi::flatpak_ref_parse(ref_.to_glib_none().0, &mut error);
            if error.is_null() {
                Ok(from_glib_full(ret))
            } else {
                Err(from_glib_full(error))
            }
        }
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`Ref`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct RefBuilder {
    builder: glib::object::ObjectBuilder<'static, Ref>,
}

impl RefBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn arch(self, arch: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("arch", arch.into()),
        }
    }

    pub fn branch(self, branch: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("branch", branch.into()),
        }
    }

    pub fn collection_id(self, collection_id: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("collection-id", collection_id.into()),
        }
    }

    pub fn commit(self, commit: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("commit", commit.into()),
        }
    }

    pub fn kind(self, kind: RefKind) -> Self {
        Self {
            builder: self.builder.property("kind", kind),
        }
    }

    pub fn name(self, name: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("name", name.into()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`Ref`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> Ref {
        self.builder.build()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Ref>> Sealed for T {}
}

pub trait RefExt: IsA<Ref> + sealed::Sealed + 'static {
    #[doc(alias = "flatpak_ref_format_ref")]
    fn format_ref(&self) -> Option<glib::GString> {
        unsafe { from_glib_full(ffi::flatpak_ref_format_ref(self.as_ref().to_glib_none().0)) }
    }

    #[cfg(feature = "v1_9_1")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v1_9_1")))]
    #[doc(alias = "flatpak_ref_format_ref_cached")]
    fn format_ref_cached(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::flatpak_ref_format_ref_cached(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_ref_get_arch")]
    #[doc(alias = "get_arch")]
    fn arch(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::flatpak_ref_get_arch(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "flatpak_ref_get_branch")]
    #[doc(alias = "get_branch")]
    fn branch(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::flatpak_ref_get_branch(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "flatpak_ref_get_collection_id")]
    #[doc(alias = "get_collection_id")]
    fn collection_id(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::flatpak_ref_get_collection_id(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_ref_get_commit")]
    #[doc(alias = "get_commit")]
    fn commit(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::flatpak_ref_get_commit(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "flatpak_ref_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> RefKind {
        unsafe { from_glib(ffi::flatpak_ref_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "flatpak_ref_get_name")]
    #[doc(alias = "get_name")]
    fn name(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::flatpak_ref_get_name(self.as_ref().to_glib_none().0)) }
    }
}

impl<O: IsA<Ref>> RefExt for O {}
